unit unitinfo;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  unitlib;

type

  { Tfminfo }

  Tfminfo = class(TForm)
    btn_close: TButton;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    lb_custom: TLabel;
    lb_libversion: TLabel;
    lb_mcu1version: TLabel;
    lb_mcu2packet: TLabel;
    lb_mcu2sensor: TLabel;
    lb_mcu2version: TLabel;
    lb_pixel: TLabel;
    lb_product: TLabel;
    lb_sensor: TLabel;
    lb_serialno: TLabel;
    lb_vendor: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    devcount : Integer;
    devindex : integer;
    Procedure GetDeviceInfo;
    Procedure ClearInfo;
  end;

var
  fminfo: Tfminfo;

implementation

{$R *.lfm}

{ Tfminfo }

procedure Tfminfo.FormCreate(Sender: TObject);
begin
  devcount := 0;
  devindex := -1;
end;

procedure Tfminfo.FormShow(Sender: TObject);
begin
  GetDeviceInfo;
end;

procedure Tfminfo.GetDeviceInfo;
var ierr : integer;
    wversion : Word = 0;
    wsensortype : word = 0;
    wpixelcount : word = 0;
    packetlength : integer = 0;
    dwcustom : dword = 0;
begin
  ClearInfo;
  if devcount > 0 then
  begin
    lb_vendor.Caption := ls_getvendorname(devindex);
    lb_product.Caption := ls_getproductname(devindex);
    lb_serialno.Caption := ls_getserialnumber(devindex);

    wversion := ls_getmcu1version(devindex);
    lb_mcu1version.Caption := IntToHex(hi(wversion),2)+'.'+IntToHex(lo(wversion),2);
    ierr := ls_getmcu2version(wversion,1000);
    if ierr = 0 then lb_mcu2version.Caption := IntToHex(hi(wversion),2)+'.'+IntToHex(lo(wversion),2)
    else lb_mcu2version.Caption := '???';

    ierr := ls_getsensortype(wsensortype,wpixelcount,1000);
    if ierr = 0 then
    begin
      lb_pixel.Caption := IntToStr(wpixelcount);
      lb_sensor.Caption := '0x'+IntToHex(wsensortype,4)+' ('+ls_getsensorname(wsensortype)+')';
    end else
    begin
      lb_pixel.Caption := '???';
      lb_sensor.Caption := '???';
    end;

    ierr := ls_getmcu2sensortype(wsensortype,1000);
    if ierr = 0 then
    begin
      lb_mcu2sensor.Caption := '0x'+IntToHex(wsensortype,4)+' ('+ls_getsensorname(wsensortype)+')';
    end else lb_mcu2sensor.Caption := '???';

    ierr := ls_getpacketlength(packetlength,1000);
    if ierr = 0 then
    begin
      lb_mcu2packet.Caption := IntToStr(packetlength)+' Bytes';
    end else lb_mcu2packet.Caption := '???';

    ierr := ls_customfirmware(dwcustom,1000);
    if ierr = 0 then
    begin
      lb_custom.Caption := IntToStr(dwcustom);
    end else lb_custom.Caption := '???';

    wversion := ls_libversion;
    lb_libversion.Caption := IntToHex(hi(wversion),2)+'.'+IntToHex(lo(wversion),2);
  end;
end;

procedure Tfminfo.ClearInfo;
begin
  lb_vendor.Caption      := '---';
  lb_product.Caption     := '---';
  lb_serialno.Caption    := '---';
  lb_mcu1version.Caption := '---';
  lb_mcu2version.Caption := '---';
  lb_pixel.Caption       := '---';
  lb_sensor.Caption      := '---';
  lb_mcu2sensor.Caption  := '---';
  lb_mcu2packet.Caption  := '---';
  lb_custom.Caption      := '---';
end;

end.

