unit unitlib;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

{$LINKLIB c}

const
  USBLC_LIB = 'libusblcpi.so';


function ls_libversion : word; cdecl; external USBLC_LIB;
procedure ls_initialize(pipesize, packetlength : integer); cdecl; external USBLC_LIB;
function ls_enumdevices : integer; cdecl; external USBLC_LIB;
function ls_getmcu1version(idx: integer): word; cdecl; external USBLC_LIB;
function ls_getvendorname(idx: integer): pchar; cdecl; external USBLC_LIB;
function ls_getproductname(idx: integer): pchar; cdecl; external USBLC_LIB;
function ls_getserialnumber(idx: integer): pchar; cdecl; external USBLC_LIB;
function ls_devicecount : byte; cdecl; external USBLC_LIB;
function ls_currentdeviceindex : integer; cdecl; external USBLC_LIB;
function ls_opendevicebyindex(idx: integer): integer; cdecl; external USBLC_LIB;
function ls_opendevicebyserial(pcserialnum: pchar): integer; cdecl; external USBLC_LIB;
function ls_closedevice : integer; cdecl; external USBLC_LIB;
procedure ls_waitforpipe(dwtimeout : dword); cdecl; external USBLC_LIB;
function ls_getpipe(lpBuffer : Pointer; nNumberOfBytesToRead : Integer) : Integer; cdecl; external USBLC_LIB;
function ls_setpacketlength(packetlength : integer) : integer; cdecl; external USBLC_LIB;
function ls_getfps : dword; cdecl; external USBLC_LIB;
function ls_ep6stat(var ucstat: byte; timeout : dword): integer; cdecl; external USBLC_LIB;
function ls_resetfifo(timeout : dword): integer; cdecl; external USBLC_LIB;
function ls_getsensortype(var wsensortype, wpixelcount: word; timeout : dword): integer; cdecl; external USBLC_LIB;
function ls_geterrorstring(iErr : integer) : PChar; cdecl; external USBLC_LIB;

//------------------------------------------------------------------------------
function ls_setmode(ucmode : byte; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_setstate(ucstate : byte; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_setinttime(dwinttime, timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_getmcu2version(var wversion : word; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_getmcu2sensortype(var wsensortype : word; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_getmode(var ucmode : byte; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_getstate(var ucstate : byte; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_getinttime(Var dwinttime : dword; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_getpacketlength(var packetlength : integer; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_customfirmware(var dwcustom : dword; timeout : dword) : integer; cdecl; external USBLC_LIB;

//------------------------------------------------------------------------------
function ls_getsensorconfigmask(wsensortype : word;
                                var wmaskand, wmaskor: word) : integer; cdecl; external USBLC_LIB;
function ls_getsensormuxmask(wsensortype : word;
                             var wmaskand, wmaskor: word) : integer; cdecl; external USBLC_LIB;
function ls_getsensordefaultparameter(wsensortype : word;
                            var wconfig, wmux, wrpga, wroffset, wgpga, wgoffset,
                            wbpga, wboffset : word) : integer; cdecl; external USBLC_LIB;
function ls_getsensorname(wsensortype : word) : pchar; cdecl; external USBLC_LIB;
function ls_getminmaxtime(wsensortype : word; var tmin, tmax : dword) : integer; cdecl; external USBLC_LIB;

//------------------------------------------------------------------------------
function ls_savesettings(timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_getadcconfig(var wconfig : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_getadcmux(var wmux : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_getadcpga1(var wpga : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_getadcpga2(var wpga : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_getadcpga3(var wpga : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_getadcoffset1(var woffset : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_getadcoffset2(var woffset : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_getadcoffset3(var woffset : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;

function ls_setadcconfig(wConfig : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadcmux(wmux : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadcpga(wRPGA, wGPGA, wBPGA : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadc3xpga(wPGA : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadcpga1(wPGA : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadcpga2(wPGA : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadcpga3(wPGA : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadcoffset(wROffSet, wGOffSet, wBOffSet : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadc3xoffset(woffset : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadcoffset1(woffset : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadcoffset2(woffset : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadcoffset3(woffset : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;

//------------------------------------------------------------------------------
function ls_readi2c(i2c_addr : byte; pbuf : pointer; var wlength : word;
                    var ucstate : byte; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_writei2c(i2c_addr : byte; pbuf : pointer; wlength : word;
                     var ucstate : byte; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_seti2cfreq(freq : byte; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_geti2cfreq(var freq : byte; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_geti2cstat(var stat : byte; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_geti2cstring(stat : byte) : pchar; cdecl; external USBLC_LIB;


implementation

end.

